if(isFile("Add-Ons/System_ReturnToBlockland/server.cs"))
{
	if(!$RTB::RTBR_ServerControl_Hook)
	{
		exec("Add-Ons/System_ReturnToBlockland/RTBR_ServerControl_Hook.cs");
	}
	RTB_registerPref("Terminal Fall Speed", "Terminal Fall Damage", "$Swol::TerminalFallSpeed", "int 30 500", "Server_TerminalFalling",80,0,0,"Rtb_TerminalFall_VarChange");
}
else
{
	$Swol::TerminalFallSpeed = 60;
}
package swol_terminalFall
{
	function Rtb_TerminalFall_VarChange(%oldVal, %newVal)
	{
		schedule(5, 0, "messageAll", '', "\c3+ Terminal Fall Damage\c0 - Fall Speed has been set to \c2" @ $Swol::TerminalFallSpeed @ "\c0.");
	}
	function gameConnection::createPlayer(%this,%pos)
	{
		%this.fallLoopSched = %this.schedule(500,fallLoop);
		parent::createPlayer(%this,%pos);
	}
	function gameConnection::fallLoop(%this)
	{
		cancel(%this.fallLoopSched);
		if(!isObject(%this.player))
		return;
		if(%this.noTerminalFalling)
		return;
		if(!isObject(%this.minigame))
		return;
		if(!%this.minigame.fallingDamage)
		return;
		%vehicle = %this.player.getObjectMount();
		
		if(%vehicle)
		{
			%this.fallLoopSched = %this.schedule(500,fallLoop);
			return;
		}

		%player = %this.player;
		%velocity = getWord(%player.getVelocity(),2);
		if(%velocity <= -$Swol::TerminalFallSpeed)
		{
			%player.damage(%player,%player.getPosition(),1000,$DamageType::Fall);
		}
		if(%velocity-10 <= -$Swol::TerminalFallSpeed)
		{
			%this.fallLoopSched = %this.schedule(100,fallLoop);
			return;
		}
		if(%velocity == 0)
		{
			%this.fallLoopSched = %this.schedule(800,fallLoop);
			return;
		}
		%this.fallLoopSched = %this.schedule(500,fallLoop);
	}
};
ActivatePackage(swol_TerminalFall);